--Checkers
--V.1.0
--This version includes debug commands
--This version does not include a turn limiter
--The code should be condensed

oddeven = function (x) 
if (x % 2 == 0) then
    return true
else
    return false
end end

function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

function love.load()
love.window.setMode(400,400)
preset1 =
{
{0,1,0,1,0,1,0,1},
{1,0,1,0,1,0,1,0},
{0,1,0,1,0,1,0,1},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{2,0,2,0,2,0,2,0},
{0,2,0,2,0,2,0,2},
{2,0,2,0,2,0,2,0}
}

pressedHistory = {0,0,0}
pressed = {0,0,0}
board = preset1
turn = 1
end 

function love.update()
x, y = love.mouse.getPosition( )
gridX = math.floor(x/50) + 1
gridY = math.floor(y/50) + 1
for i=1,8 do if board[8][i] == 1 then board[8][i] = 11 end end 
for i=1,8 do if board[1][i] == 2 then board[1][i] = 12 end end
end 




changeBoard = function(a,b) 
for w=1,8 do 
	for h=1,8 do 
		if board[w][h]==a then board[w][h]=b end
	end 
	end 
end 

moveSquare = function(a,b)
if 
 board[a][b] == 5 or board[a][b] == 6 or board[a][b] == 7 or board[a][b] == 8 or board[a][b] == 9 or board[a][b] == 10 or board[a][b] == 17 or board[a][b] == 18 or board[a][b] == 19 or board[a][b] == 20 then return true else return false end
end

--1 red piece			5 move red  		9 jump blue right
--2 blue piece 			6 move blue			10 jump blue left
--3 active red piece	7 jump red right	11 King red
--4 active blue piece	8 jump red left		12 King Blue
function love.mousepressed(x, y, button, istouch)
    if button == 1 then -- Versions prior to 0.10.0 use the MouseConstant 'l'
	-- test the type of move/piece that was clicked on.
	if board[gridY][gridX] == 3 or board[gridY][gridX] == 4 or board[gridY][gridX] == 13 or board[gridY][gridX] == 14 then pressedHistory = {0,0,0} end
	if board[gridY][gridX] == 0 then pressed = {0,0,0} end
	if board[gridY][gridX] == 1 then board[gridY][gridX] = 3 pressed = {gridY,gridX,1} end
	if board[gridY][gridX] == 2 then board[gridY][gridX] = 4 pressed = {gridY,gridX,2} end
	if board[gridY][gridX] == 11 then board[gridY][gridX] = 13 pressed = {gridY,gridX,11} end
	if board[gridY][gridX] == 12 then board[gridY][gridX] = 14 pressed = {gridY,gridX,12} end
	if moveSquare(gridY,gridX) == false then  	
		if pressedHistory[3] ~= 0 then board[pressedHistory[1]][pressedHistory[2]] = pressedHistory[3] end
	else 
		if board[gridY][gridX] == 5 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,5} end
		if board[gridY][gridX] == 6 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,6} end
		if board[gridY][gridX] == 7 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,7} board[gridY - 1][gridX - 1] = 0 end
		if board[gridY][gridX] == 8 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,8} board[gridY - 1][gridX + 1] = 0 end
		if board[gridY][gridX] == 17 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,17} board[gridY + 1][gridX - 1] = 0 end
		if board[gridY][gridX] == 18 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,18} board[gridY + 1][gridX + 1] = 0 end
		if board[gridY][gridX] == 9 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,9} board[gridY + 1][gridX - 1] = 0 end
		if board[gridY][gridX] == 10 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,10} board[gridY + 1][gridX + 1] = 0 end
		if board[gridY][gridX] == 19 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,19} board[gridY - 1][gridX - 1] = 0 end
		if board[gridY][gridX] == 20 then board[gridY][gridX] = pressedHistory[3] board[pressedHistory[1]][pressedHistory[2]] = 0 pressed = {gridY,gridX,20} board[gridY - 1][gridX + 1] = 0 end
		pressed = {0,0,0}
	end
	  
	--test for possible moves
	changeBoard(5,0)
	changeBoard(6,0)
	changeBoard(7,0) 
	changeBoard(8,0)
	changeBoard(9,0) 
	changeBoard(10,0)
	changeBoard(17,0)
	changeBoard(18,0)
	changeBoard(19,0)
	changeBoard(20,0)
	if board[gridY][gridX] == 3 then 
		if board[pressed[1]+1][pressed[2]+1] == 0 then board[pressed[1]+1][pressed[2]+1] = 5 end 
		if board[pressed[1]+1][pressed[2]-1] == 0 then board[pressed[1]+1][pressed[2]-1] = 5 end 
		if gridY < 7 then 
		if board[pressed[1]+1][pressed[2]+1] == 2 or board[pressed[1]+1][pressed[2]+1] == 12  then if board[pressed[1]+2][pressed[2]+2] == 0 then board[pressed[1]+2][pressed[2]+2] = 7 end end
		if board[pressed[1]+1][pressed[2]-1] == 2 or board[pressed[1]+1][pressed[2]-1] == 12 then if board[pressed[1]+2][pressed[2]-2] == 0 then board[pressed[1]+2][pressed[2]-2] = 8 end end 		
		end
	end
	if board[gridY][gridX] == 13 then 
	if gridY ~= 8 then 
		if board[pressed[1]+1][pressed[2]+1] == 0 then board[pressed[1]+1][pressed[2]+1] = 5 end 
		if board[pressed[1]+1][pressed[2]-1] == 0 then board[pressed[1]+1][pressed[2]-1] = 5 end 
		if gridY < 7 then
		if board[pressed[1]+1][pressed[2]+1] == 2 or board[pressed[1]+1][pressed[2]+1] == 12 then if board[pressed[1]+2][pressed[2]+2] == 0 then board[pressed[1]+2][pressed[2]+2] = 7 end end
		if board[pressed[1]+1][pressed[2]-1] == 2 or board[pressed[1]+1][pressed[2]-1] == 12 then if board[pressed[1]+2][pressed[2]-2] == 0 then board[pressed[1]+2][pressed[2]-2] = 8 end end 
		end
		end
		if gridY ~= 1 then
		if board[pressed[1]-1][pressed[2]+1] == 0 then board[pressed[1]-1][pressed[2]+1] = 5 end 
		if board[pressed[1]-1][pressed[2]-1] == 0 then board[pressed[1]-1][pressed[2]-1] = 5 end 
		if gridY > 2 then 
		if board[pressed[1]-1][pressed[2]+1] == 2 or board[pressed[1]-1][pressed[2]+1] == 12 then if board[pressed[1]-2][pressed[2]+2] == 0 then board[pressed[1]-2][pressed[2]+2] = 17 end end
		if board[pressed[1]-1][pressed[2]-1] == 2 or board[pressed[1]-1][pressed[2]-1] == 12 then if board[pressed[1]-2][pressed[2]-2] == 0 then board[pressed[1]-2][pressed[2]-2] = 18 end end
		end
	end 
	end
  	if board[gridY][gridX] == 4 then 
		if board[pressed[1]-1][pressed[2]+1] == 0 then board[pressed[1]-1][pressed[2]+1] = 6 end 
		if board[pressed[1]-1][pressed[2]-1] == 0 then board[pressed[1]-1][pressed[2]-1] = 6 end 
		if gridY > 2 then 
		if board[pressed[1]-1][pressed[2]+1] == 1 or board[pressed[1]-1][pressed[2]+1] == 11 then if board[pressed[1]-2][pressed[2]+2] == 0 then board[pressed[1]-2][pressed[2]+2] = 9 end end
		if board[pressed[1]-1][pressed[2]-1] == 1 or board[pressed[1]-1][pressed[2]-1] == 11 then if board[pressed[1]-2][pressed[2]-2] == 0 then board[pressed[1]-2][pressed[2]-2] = 10 end end 
		end
	end     
	if board[gridY][gridX] == 14 then 
	if gridY ~= 1 then 
		if board[pressed[1]-1][pressed[2]+1] == 0 then board[pressed[1]-1][pressed[2]+1] = 6 end 
		if board[pressed[1]-1][pressed[2]-1] == 0 then board[pressed[1]-1][pressed[2]-1] = 6 end 
		if gridY > 2 then 
		if board[pressed[1]-1][pressed[2]+1] == 1 or board[pressed[1]-1][pressed[2]+1] == 11 then if board[pressed[1]-2][pressed[2]+2] == 0 then board[pressed[1]-2][pressed[2]+2] = 9 end end
		if board[pressed[1]-1][pressed[2]-1] == 1 or board[pressed[1]-1][pressed[2]-1] == 11 then if board[pressed[1]-2][pressed[2]-2] == 0 then board[pressed[1]-2][pressed[2]-2] = 10 end end 
		end
		end
		if gridY ~= 8 then
		if board[pressed[1]+1][pressed[2]+1] == 0 then board[pressed[1]+1][pressed[2]+1] = 6 end 
		if board[pressed[1]+1][pressed[2]-1] == 0 then board[pressed[1]+1][pressed[2]-1] = 6 end 
		if gridY < 7 then
		if board[pressed[1]+1][pressed[2]+1] == 1 or board[pressed[1]+1][pressed[2]+1] == 11 then if board[pressed[1]+2][pressed[2]+2] == 0 then board[pressed[1]+2][pressed[2]+2] = 19 end end
		if board[pressed[1]+1][pressed[2]-1] == 1 or board[pressed[1]+1][pressed[2]-1] == 11 then if board[pressed[1]+2][pressed[2]-2] == 0 then board[pressed[1]+2][pressed[2]-2] = 20 end end
		end
	end end
	
	pressedHistory = pressed
   end
   
   if button == 2 then os.execute("cls") 
   for i=1,8 do print(dump(board[i])) end  print(dump(pressedHistory)) end 
   
end


function love.draw()
height = 400
width = 400
squareWidth = width / 8
squareHeight = height / 8
love.graphics.setColor(255, 255, 255, 200)

for w=1,8 do 
 for h=1,8 do
	if oddeven(w) == oddeven(h) then love.graphics.rectangle("fill", w * squareWidth - squareWidth, h * squareHeight - squareHeight, squareWidth, squareHeight)end 
end
end
for a=1,8 do 
	for b=1,8 do 
	 --draw checkers
	 if board[a][b] == 1 then love.graphics.setColor(255, 0, 0, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2) end 
	 if board[a][b] == 2 then love.graphics.setColor(0, 0, 255, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2) end 
	 if board[a][b] == 11 then love.graphics.setColor(255, 215, 0, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2) love.graphics.setColor(255, 0, 0, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2 - 5) end 
	 if board[a][b] == 12 then love.graphics.setColor(255, 215, 0, 255) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2) love.graphics.setColor(0, 0, 255, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2 - 5) end 
     --draw active moves
	 if moveSquare(a,b) == true then love.graphics.setColor(0, 255, 0, 255) love.graphics.rectangle("fill", b * squareWidth - squareWidth, a * squareHeight - squareHeight, squareWidth, squareHeight) end
	 --draw green circle where active checker is
	if board[a][b] == 3 or board[a][b] == 4 or board[a][b] == 13 or board[a][b] == 14 then love.graphics.setColor(0, 255, 0, 200) love.graphics.circle("fill", b * squareWidth - squareWidth/2, a * squareHeight - squareHeight/2, squareWidth/2)end 
end
end 
end 